#ifndef RAWRUNTAIL_H
#define RAWRUNTAIL_H

#include "DAQDataFormats/RawRunHeader.h"


namespace daqdataformats {

 
  class RawRunTail: public RawRunHeader{

  
  public:

    RawRunTail();                              //! The default constructor
    RawRunTail(const RawRunTail& copy_in);     //! Deep copy constructor
    RawRunTail(void* millisliceheader_buffer); //! Shallow copy constructor
    /// Destructor
    ~RawRunTail();

    /// Deep Copy
    void  copy(const RawRunTail& copy_in);
    
    /// Initialization of the data members.
    void init();

  private:

    /// The actual internal buffer (not a pointer)
    uint32_t  _InternalBuffer[RUNHEADER_SIZE];

  };
  
  
} // END NAMESPCE daqdataformats
#endif /* RAWRUNTAIL_H */
