#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawConfigurationBlock.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawConfigurationBlock
int main(){
  
std::cout<<"RawConfigurationBlock Test"<<std::endl;

std::cout<<"Empty RawConfigurationBlock1:"<<std::endl;
RawConfigurationBlock *header1 = new RawConfigurationBlock();
header1->print();std::cout<<"\n";

std::cout<<"\nNon empty RawConfigurationBlock2:"<<std::endl;

RawConfigurationBlock *header2 = new RawConfigurationBlock();
//header2->setMarkerHi1(0);
//header2->setMarkerHi2(1);
//header2->setMarkerLo1(uint32_t);
//header2->setMarkerLo2(uint32_t);
header2->setConfigurationHeaderVersion(1);
header2->setResourceManagerID(2);
header2->setRunNumber(3);
header2->setRunType(4);
header2->setPartition(6);
header2->setSubrun(7);
header2->setDetectorID(3);
//header2->setSystemNumber(8);
header2->setSystemVersionIDX(8);
header2->addSystem(1, 2);
header2->addSystem(2, 3);
header2->addSystem(4, 5);

std::string sss="hellothere";
header2->setNamespace(sss);
header2->close();


header2->print();std::cout<<"\n";

unsigned int buffer[100];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting RawConfigurationBlock2 to a buffer... ";
header2->writeData(pbuffer);

std::cout<<"\nReading the buffer to RawConfigurationBlock1";
header1->readData(buffer);

std::cout<<"RawConfigurationBlock1 now:"<<std::endl;
header1->print();std::cout<<"\n";




RawConfigurationBlock header3(*header1);
header3.print();;std::cout<<"\n";




} // END MAIN
