#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawConfigurationHeader.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawConfigurationHeader
int main(){
  
std::cout<<"RawConfigurationHeader Test"<<std::endl;

std::cout<<"Empty RawConfigurationHeader1:"<<std::endl;
RawConfigurationHeader *header1 = new RawConfigurationHeader();
header1->print();std::cout<<"\n";

std::cout<<"\nNon empty RawConfigurationHeader2:"<<std::endl;

RawConfigurationHeader *header2 = new RawConfigurationHeader();
//header2->setMarkerHi1(0);
//header2->setMarkerHi2(1);
//header2->setMarkerLo1(uint32_t);
//header2->setMarkerLo2(uint32_t);
header2->setConfigurationHeaderVersion(1);
header2->setResourceManagerID(2);
header2->setRunNumber(3);
header2->setRunType(4);
header2->setPartition(6);
header2->setSubrun(7);
header2->setSystemNumber(8);
header2->setSystemVersionIDX(9);
header2->print();std::cout<<"\n";




return 0;

unsigned int buffer[100];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting RawConfigurationHeader2 to a buffer... ";
header2->writeData(pbuffer);

std::cout<<"\nReading the buffer to RawConfigurationHeader1";
header1->readData(buffer);

std::cout<<"RawConfigurationHeader1 now:"<<std::endl;
header1->print();std::cout<<"\n";


RawConfigurationHeader header3(header1);
header3.print();;std::cout<<"\n";

RawConfigurationHeader header4;
unsigned int* pointer = (unsigned int*)header3.getBuffer();
header4.setBufferSource(pointer);
header4.print();



} // END MAIN
