#include <vector>
#include <stdio.h>
#include <stdlib.h>

#include "DAQDataFormats/RawMilliSlice.h"
#include "DAQDataFormats/RawDataBlock.h"
using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){
  


RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();

NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 56;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);


unsigned int buffer[100];
unsigned int* pbuffer = (unsigned int*) buffer; //pointer to the buffer
nanoslice_nonempty->writeData(pbuffer);

pbuffer = (unsigned int*) buffer;
microslice1->addNanoSlice(pbuffer);
microslice1->setLowWord(1);
microslice1->setHighWord(2);

unsigned int  slice_buffer[1000];
unsigned int* pslice_buffer = (unsigned int*)slice_buffer;
microslice1->writeData(pslice_buffer);

//microslice1->print();



RawMilliSlice *millislice1 = new RawMilliSlice();
        millislice1->setDiblockId(1);
        millislice1->setDCMId(2);
        millislice1->setDetId(3);
        millislice1->setVersion(1);
        millislice1->setDestBuffID(4);
        millislice1->setPartition(5);
        millislice1->setTimeStartLow(6);
        millislice1->setTimeStartHigh(7);
        millislice1->setTimeLength(8);




microslice1->print();



RawDataBlock *datablock1 = new RawDataBlock();
datablock1->setBuffId(12);
datablock1->setTrigNumLo(13);
datablock1->setVersion(14);
datablock1->addMicroBlock(millislice1->getBuffer(), pslice_buffer);;
//datablock1->print();

datablock1->writeData(pslice_buffer);

RawDataBlock *datablock2 = new RawDataBlock();
datablock2->readData(pslice_buffer);
RawDataBlock datablock3(*datablock2);
RawDataBlock datablock4(datablock3);
datablock4.print();


//datablock4.setFloatingMicroBlock(0);
//datablock4.getFloatingMicroBlock()->print();

datablock4.close();
datablock4.print();

return 0;

} // END MAIN
