#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawEventHeader.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawEventHeader
int main(){
  
std::cout<<"RawEventHeader Test"<<std::endl;

std::cout<<"Empty Eventheader1:"<<std::endl;
RawEventHeader *header1 = new RawEventHeader();
header1->print();std::cout<<"\n";

std::cout<<"\nNon empty Eventheader2:"<<std::endl;


RawEventHeader *header2 = new RawEventHeader();
    header2->setMarkerLeft(1);
    header2->setMarkerRight(2);
    header2->setVersion(3);
    header2->setDataLoggerID(4);
    header2->setRunNumber(5);
    header2->setRunType(6);
    header2->setConfigIDX(7);
    header2->setPartition(8);
    header2->setSubrun(9);
    header2->setEventNumberLo(10);
    header2->setEventNumberHi(11);
    header2->setEventType(12);
    header2->setEventSize(13);
    
header2->print();std::cout<<"\n";


unsigned int buffer[10];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting Eventheader2 to a buffer... ";
header2->writeData(pbuffer);
printf("Buffer = 0x%08x\n", buffer[0]);

std::cout<<"\nReading the buffer to Eventheader1";
header1->readData(buffer);

std::cout<<"Eventheader1 now:"<<std::endl;
header1->print();std::cout<<"\n";

RawEventHeader header3(header1);
RawEventHeader header4(header3);
header4.print();

return 0;
} // END MAIN
