#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawEventTail.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawEventTail
int main(){
  
std::cout<<"RawEventTail Test"<<std::endl;

std::cout<<"Empty Eventtail1:"<<std::endl;
RawEventTail *header1 = new RawEventTail();
header1->print();std::cout<<"\n";

std::cout<<"\nNon empty Eventtail2:"<<std::endl;


RawEventTail *header2 = new RawEventTail();
    header2->setMarker(1);
    header2->setMarkerLeft(2);
    header2->setMarkerRight(3);
    header2->setEventNumberLo(4);
    header2->setEventNumberHi(5);
    header2->setEventSize(6);
    
header2->print();std::cout<<"\n";


unsigned int buffer[10];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting Eventtail2 to a buffer... ";
header2->writeData(pbuffer);
printf("Buffer = 0x%08x\n", buffer[0]);

std::cout<<"\nReading the buffer to Eventtail1";
header1->readData(buffer);

std::cout<<"Eventtail1 now:"<<std::endl;
header1->print();std::cout<<"\n";

RawEventTail header3(header1);
RawEventTail header4(header3);
header4.print();


return 0;
} // END MAIN
