#include <vector>
#include <stdio.h>
#include <stdlib.h>
//#include "TObject.h"
#include "DAQDataFormats/RawMilliSlice.h"
#include "DAQDataFormats/RawDataBlock.h"
#include "DAQDataFormats/RawEvent.h"
using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){
  


RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();

NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 76;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);


unsigned int buffer[100];
unsigned int* pbuffer = (unsigned int*) buffer; //pointer to the buffer
nanoslice_nonempty->writeData(pbuffer);

pbuffer = (unsigned int*) buffer;
microslice1->addNanoSlice(pbuffer);
microslice1->setLowWord(1);
microslice1->setHighWord(2);

unsigned int  slice_buffer[1000];
unsigned int* pslice_buffer = (unsigned int*)slice_buffer;
microslice1->writeData(pslice_buffer);



//printf("\n Buffer:::");
//for(int i=0;i<23;i++)
//        printf("0x%08x ",pslice_buffer[i]);



std::cout<<"HIIIIIIIIIIII\n";

RawMilliSlice *millislice1 = new RawMilliSlice();
        millislice1->setDiblockId(1);
        millislice1->setDCMId(2);
        millislice1->setDetId(3);
        millislice1->setVersion(1);
        millislice1->setDestBuffID(4);
        millislice1->setPartition(5);
        millislice1->setTimeStartLow(6);
        millislice1->setTimeStartHigh(7);
        millislice1->setTimeLength(8);



RawDataBlock *datablock1 = new RawDataBlock();
datablock1->setBuffId(12);
datablock1->setTrigNumLo(13);
datablock1->setVersion(14);
datablock1->addMicroBlock(millislice1->getBuffer(), pslice_buffer);;


datablock1->writeData(pslice_buffer);

RawTriggerHeader trig_header;
trig_header.setVersion(1);
trig_header.setSource(TRIGSRC_SIMULATED);
uint32_t buffernode = 2;
trig_header.setSourceID((trigSourceID)buffernode);

RawTriggerTime trigger_time;
trigger_time.setTriggerTimeStamp(1234);
trigger_time.setClockSource(CLOCKSRC_DUMMY);

RawTriggerRange trigger_range;
trigger_range.setTriggerLength(60);

RawTriggerMask trigger_mask;
trigger_mask.setMonteCarloFlag(1);
trigger_mask.setTrigMod(0);// who know what this is
trigger_mask.setPrescale(1); //?
trigger_mask.setTriggerMask(4);
trigger_mask.print();




//return 1;
RawTrigger trig;
trig.getTriggerMask()->setTriggerMask(4);

trig.getTriggerHeader()->setTriggerNumber(2);
//trig.getTriggerHeader()->setMasterTriggerNumber(111);

trig.print();



RawEvent e1;

//e1.getTrigger()->getTriggerHeader()->setTriggerNumber(2);
//e1.getTrigger()->getTriggerHeader()->print();
//e1.getTrigger()->print();

e1.setTrigger(trig);


e1.addDataBlock(datablock1->getBuffer());
e1.close(false);

e1.print();

e1.getTrigger()->print();
return 0;


RawEventTail *tail;
tail = e1.getTail();
tail->print();

RawEventHeader *header;
header = e1.getHeader();
header->print();


RawEvent e2(e1);
e2.print();



return 0;
} // END MAIN
