#include <vector>
#include <stdio.h>
#include <stdlib.h>

#include "DAQDataFormats/RawMilliSlice.h"
using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){
  



NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 3;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 23;
        params.Header.FrameSequenceNumber = 6;
        params.TimeStamp                  = 1002;
        params.PulseHeight                = 90;

RawNanoSlice *nanoslice_nonempty1 = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 4;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 24;
        params.Header.FrameSequenceNumber = 7;
        params.TimeStamp                  = 1003;
        params.PulseHeight                = 91;
RawNanoSlice *nanoslice_nonempty2 = new RawNanoSlice(params);

RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();
microslice1->addNanoSlice(nanoslice_nonempty->getBuffer());

RawMicroSlice *microslice2 = new RawMicroSlice();
microslice2->getTimingMarker()->generate();
microslice2->addNanoSlice(nanoslice_nonempty1->getBuffer());

RawMicroSlice *microslice3 = new RawMicroSlice();
microslice3->getTimingMarker()->generate();
microslice3->addNanoSlice(nanoslice_nonempty2->getBuffer());

std::cout<<"rawmillislice1 with added microslice"<<std::endl;
RawMilliSlice *millislice1 = new RawMilliSlice();
millislice1->setDiblockId(1);
        millislice1->setDCMId(2);
        millislice1->setDetId(3);
        millislice1->setVersion(1);
        millislice1->setDestBuffID(4);
        millislice1->setPartition(5);
        millislice1->setTimeStartLow(6);
        millislice1->setTimeStartHigh(7);
        millislice1->setTimeLength(8);
microslice1->setLowWord(1);
microslice2->setLowWord(2);

//microslice1->print();
//millislice1->addMicroSlice(microslice1->getBuffer(),true);
//millislice1->addMicroSlice(microslice2->getBuffer(),true);
millislice1->addMicroSlice(microslice3->getBuffer());
millislice1->close();
millislice1->print();
return 0;

RawMilliSlice *millislice2 = new RawMilliSlice();
millislice2->readData(millislice1->getBuffer());
millislice2->print();

RawMilliSlice m3(*millislice2);
m3.print();


RawMilliSlice m4;
unsigned int* pointer = (unsigned int*)m3.getBuffer();
m4.setBufferSource(pointer);
m4.print();


m4.setFloatingMicroSlice(0);
m4.getFloatingMicroSlice()->print();

return 0;

} // END MAIN
