#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawRunHeader.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawRunHeader
int main(){
  
std::cout<<"RawRunHeader Test"<<std::endl;

std::cout<<"Empty rawrunheader1:"<<std::endl;
RawRunHeader *header1 = new RawRunHeader();
header1->print();std::cout<<"\n";

std::cout<<"\nNon empty rawrunheader2:"<<std::endl;

RawRunHeader *header2 = new RawRunHeader();

header2->setRunNumber             (1);
header2->setRunType               (2);
header2->setConfigIDX             (3);
header2->setPartition             (4);
header2->setSubrun                (5);
header2->setRunControlVersion     (6);
header2->setRunControlID          (7);
header2->setDataLoggerVersion     (8);
header2->setDataLoggerID          (9);
header2->setRunStartTime          (10);
header2->setSubRunStartTime       (11);
header2->setSubRunEndTime         (12);
header2->setRunEndTime            (13);
header2->setTotalEvents           (14);
header2->setUniversalEventStartLo (15);
header2->setUniversalEventStartHi (16);
header2->setUniversalEventEndLo   (17);
header2->setUniversalEventEndHi   (18);
header2->setRunSize               (19);
header2->setTriggerVersion        (20);
header2->setTriggerCtrlID         (21);
header2->setTriggerMC             (1);
header2->setVTMod                 (22);
header2->setTriggerListIDX        (23);
header2->setTriggerPrescaleListIDX(24);

header2->addValidTriggerTypesLow  (1);
header2->addValidTriggerTypesLow  (1);
header2->addValidTriggerTypesLow  (2);
header2->addValidTriggerTypesHigh (0);
header2->addValidTriggerTypesHigh2(0);


header2->close();






















header2->print();std::cout<<"\n";




return 0;

unsigned int buffer[100];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting rawrunheader2 to a buffer... ";
header2->writeData(pbuffer);

std::cout<<"\nReading the buffer to rawrunheader1";
header1->readData(buffer);

std::cout<<"rawrunheader1 now:"<<std::endl;
header1->print();std::cout<<"\n";


RawRunHeader header3(header1);
header3.print();;std::cout<<"\n";

RawRunHeader header4;
unsigned int* pointer = (unsigned int*)header3.getBuffer();
header4.setBufferSource(pointer);
header4.print();



} // END MAIN
